<?php

if ( function_exists('register_sidebars') )
	register_sidebars(1);

/*********************************************************************************/
/* Register widgets and widget controls
/*********************************************************************************/
if ( function_exists('register_sidebar_widget') )
{
	register_sidebar_widget ( 'pt-random', 'web_random', 'wid-random' );
	register_sidebar_widget ( 'pt-slideshow', 'web_slideshow', 'wid-slideshow' );
	register_sidebar_widget ( 'pt-recent', 'web_recent', 'wid-recent' );
	register_sidebar_widget ( 'pt-categories', 'web_categories', 'wid-categories' );
	register_sidebar_widget ( 'pt-bookmarks', 'web_bookmarks', 'wid-latest' );
	register_sidebar_widget ( 'pt-news', 'web_news', 'wid-news' );
	register_sidebar_widget('pt-wordTube', 'web_wordTube', 'wid-wordtube');

	register_widget_control('pt-random', 'web_random_control', 300, 240);
	register_widget_control('pt-slideshow', 'web_slideshow_control', 300, 130);
	register_widget_control('pt-recent', 'web_recent_control', 300, 190);
	register_widget_control('pt-categories', 'web_categories_control', 300, 130);
	register_widget_control('pt-bookmarks', 'web_bookmarks_control', 300, 150);
	register_widget_control('pt-news', 'web_news_control', 400, 210);
	register_widget_control('pt-wordTube', 'web_wordtube_control', 300, 100);
}
/*********************************************************************************/
/* Random post widget
/*********************************************************************************/
function web_random($args)
{
	extract($args);
	$options = get_option('web_random');
	$k = $options['keepratio'] ? '1' : '0';
	$w = $options['width'];
	$h = $options['height'];
	$l = $options['limit'];
	$st = $options['showtitle'];
	$lb = $options['LBeffect'] ? '1' : '0';
	$title = empty($options['title']) ? __('Random', 'post-thumb') : $options['title'];

	?>
	<?php echo $before_widget; ?>
		<?php echo $before_title . $title . $after_title; ?>
		<ul>
			<?php get_random_thumb ('width='.$w.'&height='.$h.'&limit='.$l.'&keepratio='.$k.'&showtitle='.$st.'&LB_effect='.$lb); ?>
		</ul>
	<?php echo $after_widget; ?>
	<li style="clear:left;"></li>
        <?php
}
/*********************************************************************************/
/* Random post widget control
/*********************************************************************************/
function web_random_control()
{
	$options = $newoptions = get_option('web_random');
	if ( $_POST['web-random-submit'] )
        {
		$newoptions['keepratio'] = 	isset($_POST['web-random-keepratio']);
		$newoptions['width'] = 		strip_tags(stripslashes($_POST['web-random-width']));
		$newoptions['height'] = 	strip_tags(stripslashes($_POST['web-random-height']));
		$newoptions['limit'] = 		strip_tags(stripslashes($_POST['web-random-limit']));
		$newoptions['showtitle'] = 	strip_tags(stripslashes($_POST['web-random-showtitle']));
		$newoptions['LBeffect'] = 	isset($_POST['web-random-LBeffect']);
		$newoptions['title'] = 		strip_tags(stripslashes($_POST['web-random-title']));
	}
	if ( $options != $newoptions )
        {
		$options = $newoptions;
		update_option('web_random', $options);
	}
	$title = wp_specialchars($options['title']);
	$keepratio = $options['keepratio'] ? 'checked="checked"' : '';
	if (wp_specialchars($options['width']=='')) $width = '240'; else $width = wp_specialchars($options['width']);
	if (wp_specialchars($options['height']=='')) $height = '200'; else $height = wp_specialchars($options['height']);
	if (wp_specialchars($options['limit']=='')) $limit = '5'; else $limit = wp_specialchars($options['limit']);
	$showtitle = wp_specialchars($options['showtitle']);
	$LBeffect = $options['LBeffect'] ? 'checked="checked"' : '';
?>
	<p><label for="web-random-title"><?php _e('Title:'); ?> <input style="width: 240px;" id="web-random-title" name="web-random-title" type="text" value="<?php echo $title; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-random-keepratio"><?php _e('Keep ratio', 'post-thumb'); ?> <input class="checkbox" type="checkbox" <?php echo $keepratio; ?> id="web-random-keepratio" name="web-random-keepratio" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-random-width" style="text-align:right;"><?php _e('Width', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="web-random-width" name="web-random-width" value="<?php echo $width; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-random-height" style="text-align:right;"><?php _e('Height', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="web-random-height" name="web-random-height" value="<?php echo $height; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-random-limit" style="text-align:right;"><?php _e('Random limit', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="web-random-limit" name="web-random-limit" value="<?php echo $limit; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-random-showtitle" style="text-align:right;"><?php _e('Show title', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="web-random-showtitle" name="web-random-showtitle" value="<?php echo $showtitle; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;margin-bottom:20px;"><label for="web-random-LBeffect"><?php _e('HS effect', 'post-thumb'); ?> <input class="checkbox" type="checkbox" <?php echo $LBeffect; ?> id="web-random-LBeffect" name="web-random-LBeffect" /></label></p>
	<input type="hidden" id="web-random-submit" name="web-random-submit" value="1" />
<?php
}
/*********************************************************************************/
/* Slideshow widget
/*********************************************************************************/
function web_slideshow($args)
{
	extract($args);
	$options = get_option('web_slideshow');
	$k = $options['keepratio'] ? '1' : '0';
	$w = 240;
	$h = 200;
	$c = $options['category'];
	$title = empty($options['title']) ? __('Slideshow', 'post-thumb') : $options['title'];
	?>
	<?php echo $before_widget; ?>
		<?php echo $before_title . $title . $after_title; ?>
		<ul >
			<?php pt_slideshow('category='.$c.'&altappend=slide&width='.$w.'&height='.$h.'&keepratio='.$k); ?>
  		</ul>
	<?php echo $after_widget; ?>
	<li style="clear:left;"></li>
        <?php
}
/*********************************************************************************/
/* Slideshow widget control
/*********************************************************************************/
function web_slideshow_control()
{
	$options = $newoptions = get_option('web_slideshow');
	if ( $_POST['web-slideshow-submit'] )
        {
		$newoptions['keepratio'] = 	isset($_POST['web-slideshow-keepratio']);
		$newoptions['category'] = 	strip_tags(stripslashes($_POST['web-slideshow-category']));
		$newoptions['title'] = 		strip_tags(stripslashes($_POST['web-slideshow-title']));
	}
	if ( $options != $newoptions )
        {
		$options = $newoptions;
		update_option('web_slideshow', $options);
	}
	$title = wp_specialchars($options['title']);
	$category = wp_specialchars($options['category']);
	$keepratio = $options['keepratio'] ? 'checked="checked"' : '';
?>
	<p><label for="web-slideshow-title"><?php _e('Title:'); ?> <input style="width: 240px;" id="web-slideshow-title" name="web-slideshow-title" type="text" value="<?php echo $title; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-slideshow-keepratio"><?php _e('Keep ratio', 'post-thumb'); ?> <input class="checkbox" type="checkbox" <?php echo $keepratio; ?> id="web-slideshow-keepratio" name="web-slideshow-keepratio" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-slideshow-category" style="text-align:right;"><?php _e('Show only category', 'post-thumb'); ?> <input style="width: 40px;" type="text" value="<?php echo $category; ?>" id="web-slideshow-category" name="web-slideshow-category" /></label></p>
	<input type="hidden" id="web-slideshow-submit" name="web-slideshow-submit" value="1" />
<?php
}
/*********************************************************************************/
/* Get recent posts widget
/*********************************************************************************/
function web_recent($args)
{
	extract($args);
	$options = get_option('web_recent');
	$k = $options['keepratio'] ? '1' : '0';
	$lb = $options['LBeffect'] ? '1' : '0';
	$l = $options['limit'];
	$c = $options['category'];
	$title = empty($options['title']) ? __('Recent posts') : $options['title'];
	?>
	<?php echo $before_widget; ?>
		<?php echo $before_title . $title . $after_title; ?>
		<ul>
			<?php get_recent_thumbs('category='.$c.'&keepratio='.$k.'&limit='.$l.'&LB_effect='.$lb);	?>
		</ul>
	<?php echo $after_widget; ?>
	<li style="clear:left;"></li>
        <?php
}
/*********************************************************************************/
/* Get recent posts widget control
/*********************************************************************************/
function web_recent_control() 
{
	$options = $newoptions = get_option('web_recent');
	if ( $_POST['web-recent-submit'] ) 
        {
		$newoptions['keepratio'] = 	isset($_POST['web-recent-keepratio']);
		$newoptions['limit'] = 		strip_tags(stripslashes($_POST['web-recent-limit']));
		$newoptions['category'] = 	strip_tags(stripslashes($_POST['web-recent-category']));
		$newoptions['LBeffect'] = 	isset($_POST['web-recent-LBeffect']);
		$newoptions['title'] = 		strip_tags(stripslashes($_POST['web-recent-title']));
	}
	if ( $options != $newoptions ) 
        {
		$options = $newoptions;
		update_option('web_recent', $options);
	}
	$title = wp_specialchars($options['title']);
	$keepratio = $options['keepratio'] ? 'checked="checked"' : '';
	if (wp_specialchars($options['limit']=='')) $limit = '10'; else $limit = wp_specialchars($options['limit']);
	$category = wp_specialchars($options['category']);
	$LBeffect = $options['LBeffect'] ? 'checked="checked"' : '';
?>
	<p><label for="web-recent-title"><?php _e('Title:'); ?> <input style="width: 240px;" id="web-recent-title" name="web-recent-title" type="text" value="<?php echo $title; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-recent-keepratio"><?php _e('Keep ratio', 'post-thumb'); ?> <input class="checkbox" type="checkbox" <?php echo $keepratio; ?> id="web-recent-keepratio" name="web-recent-keepratio" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-recent-limit" style="text-align:right;"><?php _e('Number of posts', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="web-recent-limit" name="web-recent-limit" value="<?php echo $limit; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-recent-category" style="text-align:right;"><?php _e('Show only category', 'post-thumb'); ?> <input style="width: 40px;" type="text" value="<?php echo $category; ?>" id="web-recent-category" name="web-recent-category" /></label></p>
	<p style="text-align:right;margin-right:20px;margin-bottom:20px;"><label for="web-recent-LBeffect"><?php _e('HS effect', 'post-thumb'); ?> <input class="checkbox" type="checkbox" <?php echo $LBeffect; ?> id="web-recent-LBeffect" name="web-recent-LBeffect" /></label></p>
	<input type="hidden" id="web-recent-submit" name="web-recent-submit" value="1" />
<?php
}
/*********************************************************************************/
/* pt-categories widget
/*********************************************************************************/
function web_categories($args) 
{
	extract($args);
	$options = get_option('web_categories');
	$c = $options['count'] ? '1' : '0';
	$h = $options['hierarchical'] ? '1' : '0';
	$title = empty($options['title']) ? __('Categories') : $options['title'];
?>
	<?php echo $before_widget; ?>
		<?php echo $before_title . $title . $after_title; ?>
		<ul>
			<?php pt_list_categories("sort_column=name&title_li=&show_count=$c&hierarchical=$h"); ?>
		</ul>
	<?php echo $after_widget; ?>
	<li style="clear:left;"></li>
<?php
}
/*********************************************************************************/
/* pt-categories widget control
/*********************************************************************************/
function web_categories_control() 
{
	$options = $newoptions = get_option('web_categories');
	if ( $_POST['categories-submit'] ) 
        {
		$newoptions['count'] = isset($_POST['categories-count']);
		$newoptions['hierarchical'] = isset($_POST['categories-hierarchical']);
		$newoptions['title'] = strip_tags(stripslashes($_POST['categories-title']));
	}
	if ( $options != $newoptions ) 
        {
		$options = $newoptions;
		update_option('web_categories', $options);
	}
	$count = $options['count'] ? 'checked="checked"' : '';
	$hierarchical = $options['hierarchical'] ? 'checked="checked"' : '';
	$title = wp_specialchars($options['title']);
?>
	<p><label for="categories-title"><?php _e('Title:'); ?> <input style="width: 250px;" id="categories-title" name="categories-title" type="text" value="<?php echo $title; ?>" /></label></p>
	<p style="text-align:right;margin-right:40px;"><label for="categories-count"><?php _e('Show post counts', 'post-thumb'); ?> <input class="checkbox" type="checkbox" <?php echo $count; ?> id="categories-count" name="categories-count" /></label></p>
	<p style="text-align:right;margin-right:40px;"><label for="categories-hierarchical" style="text-align:right;"><?php _e('Show hierarchy', 'post-thumb'); ?> <input class="checkbox" type="checkbox" <?php echo $hierarchical; ?> id="categories-hierarchical" name="categories-hierarchical" /></label></p>
	<input type="hidden" id="categories-submit" name="categories-submit" value="1" />
<?php
}
/*********************************************************************************/
/* pt-bookmarks widget
/*********************************************************************************/
function web_bookmarks($args)
{
	extract($args);
	$options = get_option('web_bookmarks');
	$b = empty($options['html_title_before']) ? __('<h4>') : $options['html_title_before'];
	$a = empty($options['html_title_after']) ? __('</h4>') : $options['html_title_after'];
	$title = empty($options['title']) ? __('Blogroll') : $options['title'];

	if (is_home()) {
		echo $before_widget;
			echo $before_title . $title . $after_title;
			echo '<ul>';
				pt_list_bookmarks('title_before='.$b.'&title_after='.$a);
			echo '</ul>';
		echo $after_widget;
		echo '<li style="clear:left;"></li>';
	}
}
/*********************************************************************************/
/* pt-bookmarks widget control
/*********************************************************************************/
function web_bookmarks_control()
{
	$options = $newoptions = get_option('web_bookmarks');
	if ( $_POST['bookmarks-submit'] )
        {
		$newoptions['title'] = strip_tags(stripslashes($_POST['bookmarks-title']));
		$newoptions['html_title_before'] = stripslashes($_POST['bookmarks-before']);
		$newoptions['html_title_after'] = stripslashes($_POST['bookmarks-after']);
	}
	if ( $options != $newoptions )
        {
		$options = $newoptions;
		update_option('web_bookmarks', $options);
	}
	$title = wp_specialchars($options['title']);
	$html_title_before = wp_specialchars($options['html_title_before']);
	$html_title_after = $options['html_title_after'];
?>
	<p><label for="bookmarks-title"><?php _e('Title:'); ?> <input style="width: 250px;" id="bookmarks-title" name="bookmarks-title" type="text" value="<?php echo $title; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="bookmarks-before" style="text-align:right;"><?php _e('html before title', 'post-thumb'); ?> <input style="width: 200px;" id="bookmarks-before" name="bookmarks-before" type="text" value="<?php echo $html_title_before; ?>"  /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="bookmarks-after" style="text-align:right;"><?php _e('html after title', 'post-thumb'); ?> <input style="width: 200px;" id="bookmarks-after" name="bookmarks-after" type="text" value="<?php echo $html_title_after; ?>" /></label></p>
	<input type="hidden" id="bookmarks-submit" name="bookmarks-submit" value="1" />
<?php
}
/*********************************************************************************/
/* News from rss feed widget
/*********************************************************************************/
function web_news($args)
{
	extract($args);
	$options = get_option('web_news');
	$l = $options['limit'];
	$f1 = $options['feed1'];
	$f2 = $options['feed2'];
	$w = $options['words'];
	$title = empty($options['title']) ? __('News', 'post-thumb') : $options['title'];
	?>
	<?php echo $before_widget; ?>
		<?php echo $before_title . $title . $after_title; ?>
		<?php if ($f1 != '') { ?>
			<div class="startseite">
				<div class="jd_news_scroll" id="elm1">
					<ul>
						<?php pt_RSS_Import ($l,$f1,$w);  ?>
					</ul>
				</div>
			</div>
		<?php } ?>
		<?php if ($f2 != '') { ?>
		<?php } ?>
	<?php echo $after_widget; ?>
	<li style="clear:left;"></li>
<?php
}
/*********************************************************************************/
/* News from rss feed widget control
/*********************************************************************************/
function web_news_control()
{
	$options = $newoptions = get_option('web_news');
	if ( $_POST['web-news-submit'] )
        {
		$newoptions['limit'] = 		strip_tags(stripslashes($_POST['web-news-limit']));
		$newoptions['feed1'] = 		strip_tags(stripslashes($_POST['web-news-feed1']));
		$newoptions['feed2'] = 		strip_tags(stripslashes($_POST['web-news-feed2']));
		$newoptions['words'] = 		strip_tags(stripslashes($_POST['web-news-words']));
		$newoptions['title'] = 		strip_tags(stripslashes($_POST['web-news-title']));
	}
	if ( $options != $newoptions ) 
        {
		$options = $newoptions;
		update_option('web_news', $options);
	}
	$title = wp_specialchars($options['title']);
	if (wp_specialchars($options['limit']=='')) $limit = '5'; else $limit = wp_specialchars($options['limit']);
	$feed1 = wp_specialchars($options['feed1']);
	$feed2 = wp_specialchars($options['feed2']);
	if (wp_specialchars($options['words']=='')) $words = '40'; else $words = wp_specialchars($options['words']);
?>
	<p><label for="web-news-title"><?php _e('Title:'); ?> <input style="width: 240px;" id="web-news-title" name="web-news-title" type="text" value="<?php echo $title; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-news-limit" style="text-align:right;"><?php _e('Number of posts', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="web-news-limit" name="web-news-limit" value="<?php echo $limit; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-news-feed1" style="text-align:right;"><?php _e('Feed 1', 'post-thumb'); ?> <input style="width: 280px;" type="text" value="<?php echo $feed1; ?>" id="web-news-feed1" name="web-news-feed1" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-news-feed2" style="text-align:right;"><?php _e('Feed 2', 'post-thumb'); ?> <input style="width: 280px;" type="text" value="<?php echo $feed2; ?>" id="web-news-feed2" name="web-news-feed2" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="web-news-words" style="text-align:right;"><?php _e('Number of words', 'post-thumb'); ?> <input style="width: 40px;" type="text" value="<?php echo $words; ?>" id="web-news-words" name="web-news-words" /></label></p>
	<input type="hidden" id="web-news-submit" name="web-news-submit" value="1" />
<?php
}
/*********************************************************************************/
/* wordTube widget
/*********************************************************************************/
function web_wordtube($args)
{
	extract($args);

	// Each widget can store its own options. We keep strings here.
	$options = get_option('web_wordtube');
	$title = $options['title'];
	$mediaid = $options['mediaid'];
	$content = '[MEDIA='.$mediaid.']';

	// These lines generate our output.
	echo $before_widget . $before_title . $title . $after_title;
	$url_parts = parse_url(get_bloginfo('home'));
	echo '<p>'.pt_replacevideo($mediaid, $content).'</p>';
	echo $after_widget;
		
}

/*********************************************************************************/
/* wordTube widget control
/*********************************************************************************/
function web_wordtube_control()
{
	global $wpdb;
	$options = get_option('web_wordtube');
	if ( !is_array($options) )
		$options = array('title'=>'', 'mediaid'=>'0');

	if ( $_POST['wordtube-submit'] ) 
        {
        	$options['title'] = strip_tags(stripslashes($_POST['wordtube-title']));
		$options['mediaid'] = $_POST['wordtube-mediaid'];
		update_option('web_wordtube', $options);
	}

	$title = htmlspecialchars($options['title'], ENT_QUOTES);

	// The Box content
	echo '<p style="text-align:right;"><label for="wordtube-title">' . __('Title:') . ' <input style="width: 200px;" id="wordtube-title" name="wordtube-title" type="text" value="'.$title.'" /></label></p>';
	echo '<p style="text-align:right;"><label for="wordtube-mediaid">' . __('Select Media:', 'wpTube'). ' </label>';
	echo '<select size="1" name="wordtube-mediaid" id="wordtube-mediaid">';

	$tables = $wpdb->get_results("SELECT * FROM $wpdb->wordtube ORDER BY 'vid' ASC ");
	if($tables)
        {
		foreach($tables as $table) {
			echo '<option value="'.$table->vid.'" ';
			if ($table->vid == $options['mediaid']) echo "selected='selected' ";
			echo '>'.$table->name.'</option>'."\n\t";
			}
		}
	echo '</select></p>';
	echo '<input type="hidden" id="wordtube-submit" name="wordtube-submit" value="1" />';
}

function kubrick_head() {
	$head = "<style type='text/css'>\n<!--";
	$output = '';
	if ( kubrick_header_image() ) {
		$url =  kubrick_header_image_url() ;
		$output .= "#header { background: url('$url') no-repeat bottom center; }\n";
	}
	if ( false !== ( $color = kubrick_header_color() ) ) {
		$output .= "#headerimg h1 a, #headerimg h1 a:visited, #headerimg .description { color: $color; }\n";
	}
	if ( false !== ( $display = kubrick_header_display() ) ) {
		$output .= "#headerimg { display: $display }\n";
	}
	$foot = "--></style>\n";
	if ( '' != $output )
		echo $head . $output . $foot;
}

add_action('wp_head', 'kubrick_head');

function kubrick_header_image() {
	return apply_filters('kubrick_header_image', get_settings('kubrick_header_image'));
}

function kubrick_upper_color() {
	if ( strstr( $url = kubrick_header_image_url(), 'header-img.php?' ) ) {
		parse_str(substr($url, strpos($url, '?') + 1), $q);
		return $q['upper'];
	} else
		return '69aee7';
}

function kubrick_lower_color() {
	if ( strstr( $url = kubrick_header_image_url(), 'header-img.php?' ) ) {
		parse_str(substr($url, strpos($url, '?') + 1), $q);
		return $q['lower'];
	} else
		return '4180b6';
}

function kubrick_header_image_url() {
	if ( $image = kubrick_header_image() )
		$url = get_template_directory_uri() . '/images/' . $image;
	else
		$url = get_template_directory_uri() . '/images/kubrickheader.jpg';

	return $url;
}

function kubrick_header_color() {
	return apply_filters('kubrick_header_color', get_settings('kubrick_header_color'));
}

function kubrick_header_color_string() {
	$color = kubrick_header_color();
	if ( false === $color )
		return 'white';

	return $color;
}

function kubrick_header_display() {
	return apply_filters('kubrick_header_display', get_settings('kubrick_header_display'));
}

function kubrick_header_display_string() {
	$display = kubrick_header_display();
	return $display ? $display : 'inline';
}

add_action('admin_menu', 'kubrick_add_theme_page');

function kubrick_add_theme_page() {
	if ( $_GET['page'] == basename(__FILE__) ) {
		if ( 'save' == $_REQUEST['action'] ) {
			if ( isset($_REQUEST['njform']) ) {
				if ( isset($_REQUEST['defaults']) ) {
					delete_option('kubrick_header_image');
					delete_option('kubrick_header_color');
					delete_option('kubrick_header_display');
				} else {
					if ( '' == $_REQUEST['njfontcolor'] )
						delete_option('kubrick_header_color');
					else
						update_option('kubrick_header_color', $_REQUEST['njfontcolor']);

					if ( preg_match('/[0-9A-F]{6}|[0-9A-F]{3}/i', $_REQUEST['njuppercolor'], $uc) && preg_match('/[0-9A-F]{6}|[0-9A-F]{3}/i', $_REQUEST['njlowercolor'], $lc) ) {
						$uc = ( strlen($uc[0]) == 3 ) ? $uc[0]{0}.$uc[0]{0}.$uc[0]{1}.$uc[0]{1}.$uc[0]{2}.$uc[0]{2} : $uc[0];
						$lc = ( strlen($lc[0]) == 3 ) ? $lc[0]{0}.$lc[0]{0}.$lc[0]{1}.$lc[0]{1}.$lc[0]{2}.$lc[0]{2} : $lc[0];
						update_option('kubrick_header_image', "header-img.php?upper=$uc&amp;lower=$lc");
					}

					if ( isset($_REQUEST['toggledisplay']) ) {
						if ( false === get_settings('kubrick_header_display') )
							update_option('kubrick_header_display', 'none');
						else
							delete_option('kubrick_header_display');
					}
				}
			} else {

				if ( isset($_REQUEST['headerimage']) ) {
					if ( '' == $_REQUEST['headerimage'] )
						delete_option('kubrick_header_image');
					else
						update_option('kubrick_header_image', $_REQUEST['headerimage']);
				}

				if ( isset($_REQUEST['fontcolor']) ) {
					if ( '' == $_REQUEST['fontcolor'] )
						delete_option('kubrick_header_color');
					else
						update_option('kubrick_header_color', $_REQUEST['fontcolor']);
				}

				if ( isset($_REQUEST['fontdisplay']) ) {
					if ( '' == $_REQUEST['fontdisplay'] || 'inline' == $_REQUEST['fontdisplay'] )
						delete_option('kubrick_header_display');
					else
						update_option('kubrick_header_display', 'none');
				}
			}
			//print_r($_REQUEST);
			header("Location: themes.php?page=functions.php&saved=true");
			die;
		}
		add_action('admin_head', 'kubrick_theme_page_head');
	}
	add_theme_page('Customize Header', 'Header Image and Color', 'edit_themes', basename(__FILE__), 'kubrick_theme_page');
}

function kubrick_theme_page_head() {
?>
<script type="text/javascript" src="../wp-includes/js/colorpicker.js"></script>
<script type='text/javascript'>
	function pickColor(color) {
		ColorPicker_targetInput.value = color;
		kUpdate(ColorPicker_targetInput.id);
	}
	function PopupWindow_populate(contents) {
		contents += '<br /><p style="text-align:center;margin-top:0px;"><input type="button" value="Close Color Picker" onclick="cp.hidePopup(\'prettyplease\')"></input></p>';
		this.contents = contents;
		this.populated = false;
	}
	function PopupWindow_hidePopup(magicword) {
		if ( magicword != 'prettyplease' )
			return false;
		if (this.divName != null) {
			if (this.use_gebi) {
				document.getElementById(this.divName).style.visibility = "hidden";
			}
			else if (this.use_css) {
				document.all[this.divName].style.visibility = "hidden";
			}
			else if (this.use_layers) {
				document.layers[this.divName].visibility = "hidden";
			}
		}
		else {
			if (this.popupWindow && !this.popupWindow.closed) {
				this.popupWindow.close();
				this.popupWindow = null;
			}
		}
		return false;
	}
	function colorSelect(t,p) {
		if ( cp.p == p && document.getElementById(cp.divName).style.visibility != "hidden" )
			cp.hidePopup('prettyplease');
		else {
			cp.p = p;
			cp.select(t,p);
		}
	}
	function PopupWindow_setSize(width,height) {
		this.width = 162;
		this.height = 210;
	}

	var cp = new ColorPicker();
	function advUpdate(val, obj) {
		document.getElementById(obj).value = val;
		kUpdate(obj);
	}
	function kUpdate(oid) {
		if ( 'uppercolor' == oid || 'lowercolor' == oid ) {
			uc = document.getElementById('uppercolor').value.replace('#', '');
			lc = document.getElementById('lowercolor').value.replace('#', '');
			hi = document.getElementById('headerimage');
			hi.value = 'header-img.php?upper='+uc+'&lower='+lc;
			document.getElementById('header').style.background = 'url("<?php echo get_template_directory_uri(); ?>/images/'+hi.value+'") center no-repeat';
			document.getElementById('advuppercolor').value = '#'+uc;
			document.getElementById('advlowercolor').value = '#'+lc;
		}
		if ( 'fontcolor' == oid ) {
			document.getElementById('header').style.color = document.getElementById('fontcolor').value;
			document.getElementById('advfontcolor').value = document.getElementById('fontcolor').value;
		}
		if ( 'fontdisplay' == oid ) {
			document.getElementById('headerimg').style.display = document.getElementById('fontdisplay').value;
		}
	}
	function toggleDisplay() {
		td = document.getElementById('fontdisplay');
		td.value = ( td.value == 'none' ) ? 'inline' : 'none';
		kUpdate('fontdisplay');
	}
	function toggleAdvanced() {
		a = document.getElementById('jsAdvanced');
		if ( a.style.display == 'none' )
			a.style.display = 'block';
		else
			a.style.display = 'none';
	}
	function kDefaults() {
		document.getElementById('headerimage').value = '';
		document.getElementById('advuppercolor').value = document.getElementById('uppercolor').value = '#69aee7';
		document.getElementById('advlowercolor').value = document.getElementById('lowercolor').value = '#4180b6';
		document.getElementById('header').style.background = 'url("<?php echo get_template_directory_uri(); ?>/images/kubrickheader.jpg") center no-repeat';
		document.getElementById('header').style.color = '#FFFFFF';
		document.getElementById('advfontcolor').value = document.getElementById('fontcolor').value = '';
		document.getElementById('fontdisplay').value = 'inline';
		document.getElementById('headerimg').style.display = document.getElementById('fontdisplay').value;
	}
	function kRevert() {
		document.getElementById('headerimage').value = '<?php echo kubrick_header_image(); ?>';
		document.getElementById('advuppercolor').value = document.getElementById('uppercolor').value = '#<?php echo kubrick_upper_color(); ?>';
		document.getElementById('advlowercolor').value = document.getElementById('lowercolor').value = '#<?php echo kubrick_lower_color(); ?>';
		document.getElementById('header').style.background = 'url("<?php echo kubrick_header_image_url(); ?>") center no-repeat';
		document.getElementById('header').style.color = '';
		document.getElementById('advfontcolor').value = document.getElementById('fontcolor').value = '<?php echo kubrick_header_color_string(); ?>';
		document.getElementById('fontdisplay').value = '<?php echo kubrick_header_display_string(); ?>';
		document.getElementById('headerimg').style.display = document.getElementById('fontdisplay').value;
	}
	function kInit() {
		document.getElementById('jsForm').style.display = 'block';
		document.getElementById('nonJsForm').style.display = 'none';
	}
	addLoadEvent(kInit);
</script>
<style type='text/css'>
	#headwrap {
		text-align: center;
	}
	#kubrick-header {
		font-size: 80%;
	}
	#kubrick-header .hibrowser {
		width: 780px;
		height: 260px;
		overflow: scroll;
	}
	#kubrick-header #hitarget {
		display: none;
	}
	#kubrick-header #header h1 {
		font-family: 'Trebuchet MS', 'Lucida Grande', Verdana, Arial, Sans-Serif;
		font-weight: bold;
		font-size: 4em;
		text-align: center;
		padding-top: 70px;
		margin: 0;
	}

	#kubrick-header #header .description {
		font-family: 'Lucida Grande', Verdana, Arial, Sans-Serif;
		font-size: 1.2em;
		text-align: center;
	}
	#kubrick-header #header {
		text-decoration: none;
		color: <?php echo kubrick_header_color_string(); ?>;
		padding: 0;
		margin: 0;
		height: 200px;
		text-align: center;
		background: url('<?php echo kubrick_header_image_url(); ?>') center no-repeat;
	}
	#kubrick-header #headerimg {
		margin: 0;
		height: 200px;
		width: 100%;
		display: <?php echo kubrick_header_display_string(); ?>;
	}
	#jsForm {
		display: none;
		text-align: center;
	}
	#jsForm input.submit, #jsForm input.button, #jsAdvanced input.button {
		padding: 0px;
		margin: 0px;
	}
	#advanced {
		text-align: center;
		width: 620px;
	}
	html>body #advanced {
		text-align: center;
		position: relative;
		left: 50%;
		margin-left: -380px;
	}
	#jsAdvanced {
		text-align: right;
	}
	#nonJsForm {
		position: relative;
		text-align: left;
		margin-left: -370px;
		left: 50%;
	}
	#nonJsForm label {
		padding-top: 6px;
		padding-right: 5px;
		float: left;
		width: 100px;
		text-align: right;
	}
	.defbutton {
		font-weight: bold;
	}
	.zerosize {
		width: 0px;
		height: 0px;
		overflow: hidden;
	}
	#colorPickerDiv a, #colorPickerDiv a:hover {
		padding: 1px;
		text-decoration: none;
		border-bottom: 0px;
	}
</style>
<?php
}

function kubrick_theme_page() {
	if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>Options saved.</strong></p></div>';
?>
<div class='wrap'>
	<div id="kubrick-header">
		<h2>Header Image and Color</h2>
		<div id="headwrap">
			<div id="header">
				<div id="headerimg">
					<h1><?php bloginfo('name'); ?></h1>
					<div class="description"><?php bloginfo('description'); ?></div>
				</div>
			</div>
		</div>
		<br />
		<div id="nonJsForm">
			<form method="POST">
				<div class="zerosize"><input type="submit" name="defaultsubmit" value="Save" /></div>
				<label for="njfontcolor">Font Color:</label><input type="text" name="njfontcolor" id="njfontcolor" value="<?php echo kubrick_header_color(); ?>" /> Any CSS color (<code>red</code> or <code>#FF0000</code> or <code>rgb(255, 0, 0)</code>)<br />
				<label for="njuppercolor">Upper Color:</label><input type="text" name="njuppercolor" id="njuppercolor" value="#<?php echo kubrick_upper_color(); ?>" /> HEX only (<code>#FF0000</code> or <code>#F00</code>)<br />
				<label for="njlowercolor">Lower Color:</label><input type="text" name="njlowercolor" id="njlowercolor" value="#<?php echo kubrick_lower_color(); ?>" /> HEX only (<code>#FF0000</code> or <code>#F00</code>)<br />
				<input type="hidden" name="hi" id="hi" value="<?php echo kubrick_header_image(); ?>" />
				<label> </label><input type="submit" name="toggledisplay" id="toggledisplay" value="Toggle Text" />
				<input type="submit" name="defaults" value="Use Defaults" />
				<input type="submit" class="defbutton" name="submitform" value="&nbsp;&nbsp;Save&nbsp;&nbsp;" />
				<input type="hidden" name="action" value="save" />
				<input type="hidden" name="njform" value="true" />
			</form>
		</div>
		<div id="jsForm">
			<form style="display:inline;" method="post" name="hicolor" id="hicolor" action="<?php echo $_SERVER['REQUEST_URI']; ?>">
				<input type="button" onclick="tgt=document.getElementById('fontcolor');colorSelect(tgt,'pick1');return false;" name="pick1" id="pick1" value="Font Color"></input>
				<input type="button" onclick="tgt=document.getElementById('uppercolor');colorSelect(tgt,'pick2');return false;" name="pick2" id="pick2" value="Upper Color"></input>
				<input type="button" onclick="tgt=document.getElementById('lowercolor');colorSelect(tgt,'pick3');return false;" name="pick3" id="pick3" value="Lower Color"></input>
				<input type="button" name="revert" value="Revert" onclick="kRevert()" />
				<input type="button" value="Advanced" onclick="toggleAdvanced()" />
				<input type="submit" name="submitform" class="defbutton" value="Save" onclick="cp.hidePopup('prettyplease')" />
				<input type="hidden" name="action" value="save" />
				<input type="hidden" name="fontdisplay" id="fontdisplay" value="<?php echo kubrick_header_display(); ?>" />
				<input type="hidden" name="fontcolor" id="fontcolor" value="<?php echo kubrick_header_color(); ?>" />
				<input type="hidden" name="uppercolor" id="uppercolor" value="<?php echo kubrick_upper_color(); ?>" />
				<input type="hidden" name="lowercolor" id="lowercolor" value="<?php echo kubrick_lower_color(); ?>" />
				<input type="hidden" name="headerimage" id="headerimage" value="<?php echo kubrick_header_image(); ?>" />
			</form>
			<div id="colorPickerDiv" style="z-index: 100;background:#eee;border:1px solid #ccc;position:absolute;visibility:hidden;"> </div>
			<div id="advanced">
				<form id="jsAdvanced" style="display:none;">
					<label for="advfontcolor">Font Color (CSS): </label><input type="text" id="advfontcolor" onchange="advUpdate(this.value, 'fontcolor')" value="<?php echo kubrick_header_color(); ?>" /><br />
					<label for="advuppercolor">Upper Color (HEX): </label><input type="text" id="advuppercolor" onchange="advUpdate(this.value, 'uppercolor')" value="#<?php echo kubrick_upper_color(); ?>" /><br />
					<label for="advlowercolor">Lower Color (HEX): </label><input type="text" id="advlowercolor" onchange="advUpdate(this.value, 'lowercolor')" value="#<?php echo kubrick_lower_color(); ?>" /><br />
					<input type="button" name="default" value="Select Default Colors" onclick="kDefaults()" /><br />
					<input type="button" onclick="toggleDisplay();return false;" name="pick" id="pick" value="Toggle Text Display"></input><br />
				</form>
			</div>
		</div>
	</div>
</div>
<?php } ?>
